Adding maps component with base functionality

This commit is contained in:
Alex Epstein 2017-07-10 10:46:08 -04:00
parent 6ecdf11dd6
commit ae14194e74
1 changed files with 161 additions and 0 deletions

161
maps/maps Executable file
View File

@ -0,0 +1,161 @@
#!/bin/bash
# Author: Alexander Epstein https://github.com/alexanderepstein
currentVersion="1.11.0"
configuredClient=""
configuredPython=""
source ~/.bash_profile ## allows grabbing enviornment variable
apiKey=$MAPQUEST_API_KEY
## This function determines which http get tool the system has installed and returns an error if there isnt one
getConfiguredClient()
{
if command -v curl &>/dev/null ; then
configuredClient="curl"
elif command -v wget &>/dev/null ; then
configuredClient="wget"
elif command -v fetch &>/dev/null ; then
configuredClient="fetch"
else
echo "Error: This tool reqires either curl, wget, or fetch to be installed."
return 1
fi
}
getConfiguredPython()
{
if command -v python2 &>/dev/null ; then
configuredPython="python2"
elif command -v python &>/dev/null ; then
configuredPython="python"
else
echo "Error: This tool requires python 2 to be installed."
return 1
fi
}
python()
{
case "$configuredPython" in
python2) python2 "$@";;
python) python "$@";;
esac
}
## Allows to call the users configured client without if statements everywhere
httpGet()
{
case "$configuredClient" in
curl) curl -A curl -s "$@";;
wget) wget -qO- "$@";;
fetch) fetch -o "...";;
esac
}
checkInternet()
{
echo -e "GET http://google.com HTTP/1.0\n\n" | nc google.com 80 > /dev/null 2>&1 # query google with a get request
if [ $? -eq 0 ]; then #check if the output is 0, if so no errors have occured and we have connected to google successfully
return 0
else
echo "Error: no active internet connection" >&2 #sent to stderr
return 1
fi
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]];then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == "Y" || "$answer" == "y" ]] ;then
cd ~ || { echo 'Update Failed' ; exit 1 ; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1 ;}
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
#first direction not grepped correctly cannot grep distances correctly all other directionms are grepped correctly.
getDirections()
{
response=$(httpGet "https://www.mapquestapi.com/directions/v2/route?key=$MAPQUEST_API_KEY&from=$1&to=$2&outFormat=json&ambiguities=ignore&routeType=fastest&doReverseGeocode=false&enhancedNarrative=true&avoidTimedConditions=false")
firstDirection=$(echo $response | grep -Eo "origNarrative\":\"[a-Z -./0-9]*" | grep -Eo "[^origNarrative\":][a-Z -./0-9]*" )
tempDirections=($(echo $response | grep -Eo "\"narrative\":\"[a-Z -./0-9]*"))
distances=($(echo $response | grep -Eo "distance\":[0-9]*[.][0-9]*" | grep -Eo "[^distance\":][0-9]*[.][0-9]*" ))
count="-1"
temp=${tempDirections[0]}
for direct in "${tempDirections[@]}"
do
if [[ $(echo $direct | grep -Eo "narrative" ) == "narrative" ]];then
count=$(echo $count + 1 | bc )
directions[$count]=$temp
temp=$(echo $direct | grep -Eo "[^\"narrative:\"][a-Z 0-9./]*")
else
temp="$temp $direct"
fi
done
#for distance in $tempDistances
directions[0]=$firstDirection
}
printDirections()
{
echo
totalDist="0"
for dist in "${distances[@]}"
do
totalDist=$(echo $totalDist + $dist | bc)
done
echo "From $1 to $2 ($totalDist mi)"
echo "==================================================="
count=0
for direct in "${directions[@]}"
do
echo -n "$(echo $count + 1 | bc)). "
if [[ $direct != "" ]];then # sometimes original Narrative is blank
direct="$direct (${distances[$count]} mi)"
count=$(echo $count + 1 | bc )
echo $direct
fi
done
echo "Welcome to $2"
echo "==================================================="
echo
}
getConfiguredPython || exit 1
getConfiguredClient || exit 1
checkInternet || exit 1
getDirections Denver Boulder || exit 1
printDirections Denver Boulder || exit 1